﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using Students.Models;
using Students.Repository;

namespace RepositoryApplication.Controllers
{
    public class StudentsController : Controller
    {
        UnitOfWork unitofwork = new UnitOfWork();
        Student student;

        public ActionResult Index()
        {
            IQueryable<Student> students = unitofwork.StudentRepository.GetAll();
            return View(students);
        }

        public ActionResult Create()
        {
            return View();
        }

        [HttpPost]
        public ActionResult Create(Student student)
        {
            try
            {
                unitofwork.StudentRepository.Insert(student);
                unitofwork.Save();
                return RedirectToAction("Index");
            }
            catch
            {
                return View();
            }
        }

        public ActionResult Edit(int id)
        {
            return View();
        }

        [HttpPost]
        public ActionResult Edit(Student student)
        {
            try
            {
                unitofwork.StudentRepository.Edit(student);
                unitofwork.Save();
                return RedirectToAction("Index");
            }
            catch
            {
                return View();
            }
        }

        [HttpGet]
        public ActionResult Edit(int? id)
        {
            return View("Edit", unitofwork.StudentRepository.GetById(id.Value));
        }

        [HttpPost]
        public ActionResult Delete(int? submit)
        {
            Student student = unitofwork.StudentRepository.GetById(submit.Value);
            unitofwork.StudentRepository.Delete(student);
            unitofwork.Save();
            return View("Index", unitofwork.StudentRepository.GetAll());
        }

    }
}
